/*
 * CKEditor - The text editor for Internet - http://ckeditor.com
 * Copyright (C) 2003-2008 Frederico Caldeira Knabben
 *
 * == BEGIN LICENSE ==
 *
 * Licensed under the terms of any of the following licenses at your
 * choice:
 *
 *  - GNU General Public License Version 2 or later (the "GPL")
 *    http://www.gnu.org/licenses/gpl.html
 *
 *  - GNU Lesser General Public License Version 2.1 or later (the "LGPL")
 *    http://www.gnu.org/licenses/lgpl.html
 *
 *  - Mozilla Public License Version 1.1 or later (the "MPL")
 *    http://www.mozilla.org/MPL/MPL-1.1.html
 *
 * == END LICENSE ==
 */


findDialog = function( editor, startupPage )
{
	return {
		title : editor.lang.dlgFindAndReplaceTitle,
		resizable : CKEDITOR.DIALOG_RESIZE_NONE,
		minWidth : 400,
		minHeight : 225,
		buttons : [ CKEDITOR.dialog.cancelButton ],		//Cancel button only.
		contents : [
			{
				id : 'find',
				label : editor.lang.dlgFindTitle,
				title : editor.lang.dlgFindTitle,
				accessKey : '',
				elements : [
					{
						type : 'hbox',
						widths : [ '230px', '90px' ],
						children :
						[
							{
								type : 'text',
								id : 'txtFindFind',
								label : editor.lang.dlgReplaceFindLbl,
								isChanged : false,
								labelLayout : 'horizontal',
								accessKey : 'F',
							},
							{
								type : 'button',
								align : 'left',
								style : 'width:100%',
								label : editor.lang.dlgFindFindBtn,
								onClick : function()
								{
									alert( editor.lang.dlgFindNotFoundMsg );
								}
							},
						]
					},
					{
						type : 'checkbox',
						id : 'txtFindCaseChk',
						isChanged : false,
						label : editor.lang.dlgReplaceCaseChk,
					},
					{
						type : 'checkbox',
						id : 'txtFindWordChk',
						isChanged : false,
						label : editor.lang.dlgReplaceWordChk,
					},
				]
			},
			{
				id : 'replace',
				label : editor.lang.dlgReplaceTitle,
				accessKey : 'M',
				elements : [
					{
						type : 'hbox',
						widths : [ '230px', '90px' ],
						children :
						[
							{
								type : 'text',
								id : 'txtFindReplace',
								label : editor.lang.dlgReplaceFindLbl,
								isChanged : false,
								labelLayout : 'horizontal',
								accessKey : 'F',
							},
							{
								type : 'button',
								align : 'left',
								style : 'width:100%',
								label : editor.lang.dlgReplaceReplaceBtn,
								onClick : function()
								{
									alert( editor.lang.dlgFindNotFoundMsg );
								}
							},
						]
					},
					{
						type : 'hbox',
						widths : [ '230px', '90px' ],
						children :
						[
							{
								type : 'text',
								id : 'txtReplace',
								label : editor.lang.dlgReplaceReplaceLbl,
								isChanged : false,
								labelLayout : 'horizontal',
								accessKey : 'R',
							},
							{
								type : 'button',
								align : 'left',
								style : 'width:100%',
								label : editor.lang.dlgReplaceReplAllBtn,
								isChanged : false,
								onClick : function()
								{
									alert( editor.lang.dlgFindNotFoundMsg );
								}
							},
						]
					},
					{
						type : 'checkbox',
						id : 'txtReplaceCaseChk',
						isChanged : false,
						label : editor.lang.dlgReplaceCaseChk,
					},
					{
						type : 'checkbox',
						id : 'txtReplaceWordChk',
						isChanged : false,
						label : editor.lang.dlgReplaceWordChk,
					},
				]
			}
		],
		onShow : function()
		{
			if ( startupPage == 'replace' )
				this.getContentElement( 'replace', 'txtFindReplace' ).focus();
			else
				this.getContentElement( 'find', 'txtFindFind' ).focus();
		}
	};
};

CKEDITOR.dialog.add( 'find', function( editor ){
		return findDialog( editor, 'find' )
	}
);

CKEDITOR.dialog.add( 'replace', function( editor ){
		return findDialog( editor, 'replace' )
	}
);
